local GainsToNextRepFrame = CreateFrame("Frame")

GainsToNextRepFrame:RegisterEvent("ADDON_LOADED")
GainsToNextRepFrame:RegisterEvent("PLAYER_XP_UPDATE")
GainsToNextRepFrame:RegisterEvent("PLAYER_LEVEL_UP")
GainsToNextRepFrame:RegisterEvent("UPDATE_EXHAUSTION")
GainsToNextRepFrame:RegisterEvent("UNIT_PET")
GainsToNextRepFrame:RegisterEvent("UNIT_PET_EXPERIENCE")
GainsToNextRepFrame:RegisterEvent("ZONE_CHANGED")
GainsToNextRepFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
GainsToNextRepFrame:RegisterEvent("PLAYER_CONTROL_LOST")
GainsToNextRepFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
GainsToNextRepFrame:RegisterEvent("PLAYER_LEAVING_WORLD")
GainsToNextRepFrame:RegisterEvent("CINEMATIC_START")
GainsToNextRepFrame:RegisterEvent("CINEMATIC_STOP")
GainsToNextRepFrame:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN")
GainsToNextRepFrame:RegisterEvent("UPDATE_FACTION")
GainsToNextRepFrame:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")
GainsToNextRepFrame:RegisterEvent("PLAYER_LOGIN")

OldRep = {}
NewRep = {}
FactionName = {}

print('Gains to Next Rep loaded')

GainsToNextRepFrame:SetScript("OnEvent",

function(self,event,...)

	--print('Starting event ' .. event)

	if event == "CHAT_MSG_COMBAT_FACTION_CHANGE" --[[or event == "UPDATE_FACTION"]] then
		
		for factionIndex = 1, Factions, 1 do
			name, _, standingID, barMin, barMax, barValue, _, _, isHeader, _, hasRep, isWatched, _, factionID = GetFactionInfo(factionIndex)
			NewRep[factionIndex] = barValue
			
			if NewRep[factionIndex] > OldRep[factionIndex] then
				
				if standingID == 0 then
					StandingName = "Unknown"
					RepNeeded = -21000
				elseif standingID == 1 then
					StandingName = "|cffff0000Hostile|r"
					RepNeeded = -6000
				elseif standingID == 2 then
					StandingName = "|cfff26000Unfriendly|r"
					RepNeeded = -3000
				elseif standingID == 3 then
					StandingName = "|cffe4e400Neutral|r"
					RepNeeded = 0
				elseif standingID == 4 then
					StandingName = "|cff33ff33Friendly|r"
					RepNeeded = 3000
				elseif standingID == 5 then
					StandingName = "|cff5fe65dHonored|r"
					RepNeeded = 9000
				elseif standingID == 6 then
					StandingName = "|cff53e9bcRevered|r"
					RepNeeded = 21000
				elseif standingID == 7 then
					StandingName = "|cff2ee6e6Exalted|r"
					RepNeeded = 42000
				elseif standingID == 8 then
					StandingName = "|cff2ee6e6Maximum|r"
					RepNeeded = 42999
				end
			
				leftToNextRep = RepNeeded - NewRep[factionIndex]
				
				RepGained = NewRep[factionIndex] - OldRep[factionIndex]
				killsToNextRep = math.ceil(leftToNextRep/RepGained)
				print('|cff33ccffGained ' .. RepGained .. ' reputation with ' .. FactionName[factionIndex])
				print('|cff33ccff' .. killsToNextRep .. ' equal gains until|r ' .. StandingName)
				OldRep[factionIndex] = NewRep[factionIndex]
				
			elseif NewRep[factionIndex] < OldRep[factionIndex] then
			
				if standingID == 0 then
					StandingName = "Unknown"
				elseif standingID == 1 then
					StandingName = "|cffcc0000Minimum|r"
					RepNeeded = -21000
				elseif standingID == 2 then
					StandingName = "|cffcc0000Hated|r"
					RepNeeded = -6000
				elseif standingID == 3 then
					StandingName = "|cffff0000Hostile|r"
					RepNeeded = -3000
				elseif standingID == 4 then
					StandingName = "|cfff26000Unfriendly|r"
					RepNeeded = 0
				elseif standingID == 5 then
					StandingName = "|cffe4e400Neutral|r"
					RepNeeded = 3000
				elseif standingID == 6 then
					StandingName = "|cff33ff33Friendly|r"
					RepNeeded = 9000
				elseif standingID == 7 then
					StandingName = "|cff5fe65dHonored|r"
					RepNeeded = 21000
				elseif standingID == 8 then
					StandingName = "|cff53e9bcRevered|r"
					RepNeeded = 42000
				end
							
				leftToNextRep = RepNeeded - NewRep[factionIndex]
			
				RepLost = NewRep[factionIndex] - OldRep[factionIndex]
				
				if NewRep[factionIndex] % RepLost ==  0 then
					killsToNextRep = math.ceil(leftToNextRep/RepLost)+1
				else
					killsToNextRep = math.ceil(leftToNextRep/RepLost)
				end
				
				print('|cffff6600Lost ' .. 0 - RepLost .. ' reputation with ' .. FactionName[factionIndex])
				print('|cffff6600' .. killsToNextRep .. ' equal losses until|r ' .. StandingName)
				OldRep[factionIndex] = NewRep[factionIndex]
			end

		end
		
	elseif event == "PLAYER_ENTERING_WORLD" or event == "ADDON_LOADED" or event == "PLAYER_LOGIN" or event == "UNIT_PET" or event == "UPDATE_FACTION" or event == "ZONE_CHANGED_NEW_AREA" then
		Factions = GetNumFactions()
		for factionIndex = 1, Factions, 1 do
			name, _, standingID, barMin, barMax, barValue, _, _, isHeader, _, hasRep, isWatched, _, factionID = GetFactionInfo(factionIndex)
			OldRep[factionIndex] = barValue
			FactionName[factionIndex] = name
		end
		--print('Middle event ' .. event)
	else
		--print('Ending event ' .. event)
	end
end)